------------------------------------------------------
-- AdSpace.lua
-- Version 1500.1
------------------------------------------------------

-- Configuration
FAS_Config = { };
FAS_Config.Tooltip = true;

local function FAS_Tooltip_Hook(frame, name, count, data)

	if ( FAS_Config.Tooltip ) then
		local myFaction = (GetFactionInfo(1));
		local vendors = GFWTable.Merge(FAS_VendorInfo[myFaction][name], FAS_VendorInfo["Neutral"][name]);
		if (table.getn(vendors) > 0) then
			frame.eDone = 1;
			frame:AddLine("Found on vendors:", 0.7,1.0,0.2);
			for i, aVendor in vendors do
				frame:AddLine(aVendor, 0.7,1.0,0.2);
			end
			frame:Show();
		end
	end
	
	FAS_Old_Tooltip_Hook(frame, name, count, data);
end

function FAS_OnLoad()

	-- Register Slash Commands
	SLASH_FAS1 = "/adspace";
	SLASH_FAS2 = "/ads";
	SlashCmdList["FAS"] = function(msg)
		FAS_ChatCommandHandler(msg);
	end
	
	FAS_Old_Tooltip_Hook = LootLink_AddExtraTooltipInfo;
	LootLink_AddExtraTooltipInfo = FAS_Tooltip_Hook;

	GFWUtils.Print(GFW_COLOR_START.."Fizzwidget AdSpace initialized!"..FONT_COLOR_CODE_CLOSE);
end

function FAS_ChatCommandHandler(msg)

	-- Print Help
	if ( msg == "help" ) or ( msg == "" ) then
		GFWUtils.Print(GFW_COLOR_START.."Fizzwidget AdSpace:"..FONT_COLOR_CODE_CLOSE);
		GFWUtils.Print(GFW_COLOR_START.."/adspace (or /ads)"..FONT_COLOR_CODE_CLOSE);
		GFWUtils.Print("- "..GFW_COLOR_START.."help"..FONT_COLOR_CODE_CLOSE.." - Print this helplist.");
		GFWUtils.Print("- "..GFW_COLOR_START.."status"..FONT_COLOR_CODE_CLOSE.." - Check current settings.");
		GFWUtils.Print("- "..GFW_COLOR_START.."on|off"..FONT_COLOR_CODE_CLOSE.." - enable/disable display of vendor availability in recipe tooltips.");
		GFWUtils.Print("- "..GFW_COLOR_START.."vendor <item link>"..FONT_COLOR_CODE_CLOSE.." - Get vendor info for an item printed to chat.");
		return;
	end
	
	if (msg == "tooltip on") then
		FAS_Config.Tooltip = true;
		GFWUtils.Print(GFW_COLOR_START.."Showing vendor availability in select items tooltips."..FONT_COLOR_CODE_CLOSE);
		return;
	end
	if (msg == "tooltip off") then
		FAS_Config.Tooltip = false;
		GFWUtils.Print(GFW_COLOR_START.."Not showing vendor availability in select items tooltips."..FONT_COLOR_CODE_CLOSE);
		return;
	end
	
	if ( msg == "status" ) then
		if ( FAS_Config.Tooltip ) then
			GFWUtils.Print(GFW_COLOR_START.."Showing vendor availability in select items tooltips."..FONT_COLOR_CODE_CLOSE);
		else
			GFWUtils.Print(GFW_COLOR_START.."Not showing vendor availability in select items tooltips."..FONT_COLOR_CODE_CLOSE);
		end
		return;
	end

	local _, _, cmd, itemLink = string.find(msg, "(vendor) (.+)");
	if (cmd) then
		if not (itemLink) then
			GFWUtils.Print("Usage: "..GFW_COLOR_START.."/ads vendor <item link>"..FONT_COLOR_CODE_CLOSE);
			return;
		end
		local _, _, name = string.find(itemLink, "%[(.*)%]");
		if not (name) then
			GFWUtils.Print("Usage: "..GFW_COLOR_START.."/ads vendor <item link>"..FONT_COLOR_CODE_CLOSE);
			return;
		end
		
		local myFaction = (GetFactionInfo(1));
		local vendors = GFWTable.Merge(FAS_VendorInfo[myFaction][name], FAS_VendorInfo["Neutral"][name]);
		if (table.getn(vendors) > 0) then
			GFWUtils.Print(GFW_COLOR_START.."Found on vendors:"..FONT_COLOR_CODE_CLOSE);
			for i, aVendor in vendors do
				GFWUtils.Print(aVendor);
			end
		else
			GFWUtils.Print(GFW_COLOR_START..name..FONT_COLOR_CODE_CLOSE.." is not on any known vendors.");
		end

		return;
	end

end

